<?php
/* @package Joomla
 * @copyright Copyright (C) Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * @extension Phoca Extension
 * @copyright Copyright (C) Jan Pavelka www.phoca.cz
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die();
class PhocaMenuRenderViews
{
	
	/*
	 * VIEWS:
	 * 1 Email
	 * 2 PDF
	 * 3 Multiple Edit
	 * 4 Bootstrap 2
	 * 5 Bootstrap 3
	 * 6 Raw edit
	 * Default Table
	 */
	
	/*
	 *
	 *
	 * Daily Menu
	 *
	 *
	 */
	public static function renderDailyMenu($data, $tmpl, $params, $paramsG, $method = 0) {
		
		$method = self::setMethod($params, $method);
		$tag = PhocaMenuRenderViews::getStyle($method, $tmpl['phocagallery']);
		$paramsC['displaygroupmsg']	= $params->get( 'display_group_message', 2 );
		
		
		$oP = array();
		
		$o = self::setMainId($method);

		// HEADER (Config)
		$oddEvenBox = 0;
		if (isset($data['config'])) {
			$o .= $tag['header-o'];
			$o .= PhocaMenuRenderViews::getCustomCode($tmpl['customclockcode'], $data['config']->header, $method);
			$o .= $tag['header-c'];
			
			if ($method == 3) {
				$o .= $tag['oddbox-o'];
				$oddEvenBox = 1;
			}
			
			$date = PhocaMenuHelper::getDate($data['config']->date, $tmpl['daydateformat'], $tmpl['dateclass']);
			
			if ($method == 3) {
				$o .= $tag['date-o'] . $date . '<br/>'
				. JHTML::_('calendar', $data['config']->date, 'date['.$data['config']->id.']', 'date'.$data['config']->id, "%Y-%m-%d", array('class'=>'inputbox', 'size'=>'45',  'maxlength'=>'45')) . $tag['date-c'];
			} else if ($method == 6) {
				$oP[] = '#'.$data['config']->date;
			} else {
				$o .= $tag['date-o'] . $date . $tag['date-c'];
			}
		}

		// BODY
		if (isset($data['group'])) {
			for ($g = 0, $gr = count($data['group']); $g < $gr; $g++) {					
				
				if ($method == 3) {		
					$o .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
				} else if ($method == 6) {
					$oP[] = '###'.$data['group'][$g]->title;
					if (!empty($data['group'][$g]->message)) {
						$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
						if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
					}
				} else {
					$o .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
					if ($paramsC['displaygroupmsg'] == 1) {
						$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
					}
				}
				
				if (isset($data['item'])) { 
					$displayTaskIcons 	= 0;// we don't know if there is some row, if there will be then display icons
					$displayAddRow		= 0;// we don't know if there is some row, if not, don't display add row
					$o .= $tag['item-o'] . $tag['tableitem-o'];
					
					// Second Price, Header Group
					if ($method == 3 ) {
						$o .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
					} else {
						$o .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 1 );
					}
					// END SP
					
					for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
						// item must belong to own group
						
						if ($data['group'][$g]->id == $data['item'][$i]->catid) {
						
							// Possible tasks in multipleedit - display them only before first row
							if ($method == 3 && $displayTaskIcons == 0) {						
								$o .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
								// there is some first row
								$displayTaskIcons 	= 1;
								$displayAddRow		= 1;
							}

							$image	= $tag['spaceimg'];
							// PHOCAGALLERY Image  - - - - - -
							if ((int)$tmpl['phocagallery'] == 1) {
								$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid, $data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth );
								
							}
							// - - - - - - - - - - - - - - - - 
							
							if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
								$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
								$pricePref	= $tmpl['priceprefix'];
							} else {
								$price 		= '';
								$pricePref	= '';
							}
							
							// Second Price
							if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
								$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
								$pricePref2		= $tmpl['priceprefix'];
							} else {
								$price2 		= '';
								$pricePref2		= '';
							}
							// End SP
								
							if ($method == 3) {
								$o .= PhocaMenuRenderViews::renderFormItemME(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							} else if ($method == 6) {
								$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							} else {
								$o .= PhocaMenuRenderViews::renderFormItem(1, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							}	
						}
						
						// End Item
					}
					
					$o .= $tag['tableitem-c'] . $tag['item-c'];
					if ($method == 3) {
						if ($displayAddRow == 1) {
							$o .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 1); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
						}
					}
				}// end items
				
				 if ($method == 3) { 
					$o .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];		
				} else {
					if ($paramsC['displaygroupmsg'] == 2) {
						$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
					}
				} 
			}
		} // end group
		
		if ($method == 3 && $oddEvenBox == 1) {
			$o .= $tag['bothbox-c'];
		}

		// FOOTER (Config)
		if (isset($data['config'])) {
			$o .=  $tag['footer-o'] . $data['config']->footer .  $tag['footer-c'];
		}

		$o .= '</div>';// end phocamenu

		if ($method == 3) {
			return $o;
		} else if ($method == 6) {
			return PhocaMenuRenderViews::renderFormCompleteRE($oP);
		}
		
		$enableBBCode = $params->get( 'enable_bb_code', 0 );
		if ((int)$enableBBCode == 1) {
			$o = PhocaMenuHelper::bbCodeReplace($o);
			$o = str_replace ( '[br]', '<br />', $o );
		} else if ((int)$enableBBCode  == 2) {
			$o = str_replace ( '[br]', '<br />', $o );
		}
		$o = PhocaMenuHelper::replaceTag($o, $method);
		
		// Remove empty table - because of TCPDF
		$o = str_replace($tag['tableitem-o'].$tag['tableitem-c'], '', $o);
		
		
		
		return $o;
	}
	
	
	/*
	 *
	 *
	 * Weekly Menu
	 *
	 *
	 */
	public static function renderWeeklyMenu($data, $tmpl, $params, $paramsG, $method = 0) {
	
		$method = self::setMethod($params, $method);
		//Frontend params
		$paramsF['displaydayname']			= $params->get('displaydayname',1);
		$paramsF['displayheaderdate']		= $params->get('displayheaderdate',1);
		$paramsF['displayheader']			= $params->get('displayheader',1);
		$paramsC['displaygroupmsg']			= $params->get( 'display_group_message', 2 );
		//$paramsC['displaydaymultiplewm']	= $params->get( 'display_day_multiple_wm', 1);
		
		$app 	= JFactory::getApplication();
		$site	= $app->getName();
		
	
		$tag 		= PhocaMenuRenderViews::getStyle($method, $tmpl['phocagallery']);

		$oP = array();
		
		$o = self::setMainId($method);

		// HEADER (Config)
		if (isset($data['config'])) {
			
			if ($paramsF['displayheader'] == 1) {
				$o .= $tag['header-o'] . $data['config']->header . $tag['header-c'];
				$dateFrom 	= PhocaMenuHelper::getDate($data['config']->date_from, $tmpl['weekdateformat'], $tmpl['dateclass']);
				$dateTo 	= PhocaMenuHelper::getDate($data['config']->date_to, $tmpl['weekdateformat'], $tmpl['dateclass']);
				
				if ($method == 3) {
					$o .= $tag['date-o'] . $dateFrom . ' - ' . $dateTo . '<br/>'
					. '<table style="text-align:right;border: 0px;"><tr>'
					. '<td>' . JText::_('COM_PHOCAMENU_FIELD_DATE_FROM_LABEL') . '</td>'
					. '<td>' . JHTML::_('calendar', $data['config']->date_from,  'date_from['.$data['config']->id.']', 'date_from'.$data['config']->id, "%Y-%m-%d", array('class'=>'inputbox', 'size'=>'45',  'maxlength'=>'45')). '</td>'
					.'</tr><tr>'
					.'<td>' . JText::_('COM_PHOCAMENU_FIELD_DATE_TO_LABEL') . '</td>'
					.'<td>' . JHTML::_('calendar', $data['config']->date_to,  'date_to['.$data['config']->id.']', 'date_to'.$data['config']->id, "%Y-%m-%d", array('class'=>'inputbox', 'size'=>'45',  'maxlength'=>'45')) .'</td>'
					.'</tr></table>' . $tag['date-c'];
				
				} else if ($method == 6) {
					$oP[] = '#'.$data['config']->date_from .' - '.$data['config']->date_to;
				} else {
					if (isset($data['config']->date_from) && $data['config']->date_from != ''
					 && isset($data['config']->date_to) && $data['config']->date_to != '' && (int)$paramsF['displayheaderdate'] > 0) {
						$o .= $tag['date-o'] . $dateFrom . ' - ' . $dateTo . $tag['date-c'];
					}
				}
			
			}
			
		}

		// BODY
		
		if (isset($data['day'])) {
			for ($d = 0, $da = count($data['day']); $d < $da; $d++) {
			
				$oddEvenBox = 0;
				if ($method == 3) {
					if ($d%2==0) {
						$o .= $tag['evenbox-o'];
					} else {
						$o .= $tag['oddbox-o'];
					}
					$oddEvenBox = 1;
				}
			
				
				if ($paramsF['displaydayname'] == 1) {
					$date = PhocaMenuHelper::getDate($data['day'][$d]->title, $tmpl['daydateformat'], $tmpl['dateclass']);
				
					// Multiple Edit
					if ($method == 3) {
						$o .= $tag['datesub-o'] . $date . '<br/>'
						. JHTML::_('calendar', $data['day'][$d]->title, 'datesub[' . $data['day'][$d]->id.']', 'datesub' . $data['day'][$d]->id, "%Y-%m-%d", array('class'=>'inputbox', 'size'=>'45',  'maxlength'=>'45')) . $tag['datesub-c'];
					} else if ($method == 6) {
						$oP[] = '##'.$data['day'][$d]->title;
					} else {
						$o .= $tag['datesub-o'] . $date . $tag['datesub-c'];
					}
				}
				
				if (isset($data['group'])) {
					for ($g = 0, $gr = count($data['group']); $g < $gr; $g++) {
						
						// group must belong to own day
						if ($data['day'][$d]->id == $data['group'][$g]->catid) {
							
							if ($method == 3) {
								$o .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
	
							}  else if ($method == 6) {
								$oP[] = '###'.$data['group'][$g]->title;
								if (!empty($data['group'][$g]->message)) {
									$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
									if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
								}
							} else {
								$o .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
								if ($paramsC['displaygroupmsg'] == 1) {
									$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
								}
							}
							
							if (isset($data['item'])) {
								$displayTaskIcons 	= 0;
								$displayAddRow		= 0;
								$oI			= '';
								$o .= $tag['item-o'] . $tag['tableitem-o'];

								// Second Price, Header Group
								if ($method == 3 ) {
									$o .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
								} else {
									$o .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 2 );
								}
								// END SP
								
								for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
									
									// item must belong to own group
									if ($data['group'][$g]->id == $data['item'][$i]->catid) {
									
										// Possible tasks in multipleedit - display them only before first row
										if ($method == 3 && $displayTaskIcons == 0) {						
											$oI .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
											// there is some first row
											$displayTaskIcons 	= 1;
											$displayAddRow		= 1;
										}
							
										$image	= $tag['spaceimg'];
										// PHOCAGALLERY Image  - - - - - -
										
										if ((int)$tmpl['phocagallery'] == 1) {
											$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid,
											$data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth);
										
										}
										// - - - - - - - - - - - - - - - - 
									
										if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
											$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
											$pricePref	= $tmpl['priceprefix'];
										} else {
											$price 		= '';
											$pricePref	= '';
										}
										
										// Second Price
										if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
											$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
											$pricePref2		= $tmpl['priceprefix'];
										} else {
											$price2 		= '';
											$pricePref2		= '';
										}
										// End SP
										
										if ($method == 3) {
											$oI .= PhocaMenuRenderViews::renderFormItemME(2, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
										} else if ($method == 6) {
											$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
										} else {
											$oI .=PhocaMenuRenderViews::renderFormItem(2, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
										}
									
									}
								}
							
								if ($oI == '') {$oI = '<tr><td></td></tr>';}
								$o .= $oI . $tag['tableitem-c'] . $tag['item-c'];
								
								if ($method == 3) {
									if ($displayAddRow == 1) {
										$o .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 2); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
									}
								}
								
							} // end item
							
							if ($method == 3) {
								$o .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];	
							} else {
								if ($paramsC['displaygroupmsg'] == 2) {
									$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
								}
							}
						}
					}
				} // end group
			
				if ($method == 3 && $oddEvenBox == 1) {
					$o .= $tag['bothbox-c'];
				}
			
			}
		} // end day

		// FOOTER (Config)
		if (isset($data['config'])) {
			$o .=  $tag['footer-o'] . $data['config']->footer .  $tag['footer-c'];
		}

		$o .= '</div>';// end phocamenu	
		
		if ($method == 3) {
			return $o;
		} else if ($method == 6) {
			return PhocaMenuRenderViews::renderFormCompleteRE($oP);
		}
		
		$enableBBCode = $params->get( 'enable_bb_code', 0 );
		if ((int)$enableBBCode == 1) {
			$o = PhocaMenuHelper::bbCodeReplace($o);
			$o = str_replace ( '[br]', '<br />', $o );
		} else if ((int)$enableBBCode  == 2) {
			$o = str_replace ( '[br]', '<br />', $o );
		}
		$o = PhocaMenuHelper::replaceTag($o, $method);
		
		// Remove empty table - because of TCPDF
		$o = str_replace($tag['tableitem-o'].$tag['tableitem-c'], '', $o);
		
		return $o;
	}
	
	
	 /*
	 *
	 *
	 * Common Menu  Breakfast Menu, Lunch Menu, Dinner Menu
	 *
	 *
	 */
	public static function renderCommonMenu($data, $tmpl, $params, $paramsG, $method = 0) {
	
		$method = self::setMethod($params, $method);
		$tag = PhocaMenuRenderViews::getStyle($method, $tmpl['phocagallery']);
		$paramsC['displaygroupmsg']	=	$params->get( 'display_group_message', 2 );

		$oP = array();
		
		$o = self::setMainId($method);

		// HEADER (Config)
		$oddEvenBox = 0;
		if (isset($data['config'])) {
			$o .= $tag['header-o'] . $data['config']->header . $tag['header-c'];
		}
		
		if ($method == 3) {
			$o .= $tag['oddbox-o'];
			$oddEvenBox = 1;
		}

		// BODY
		if (isset($data['group'])) {
			for ($g = 0, $gr = count($data['group']); $g < $gr; $g++) {					
				
				if ($method == 3) {			
					$o .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
				}  else if ($method == 6) {
					$oP[] = '###'.$data['group'][$g]->title;
					if (!empty($data['group'][$g]->message)) {
						$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
						if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
					}
				} else {
					$o .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
					if ($paramsC['displaygroupmsg'] == 1) {
						$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
					}
				}
				
				if (isset($data['item'])) {
					$displayTaskIcons 	= 0;
					$displayAddRow		= 0;
					$o .= $tag['item-o'] . $tag['tableitem-o'];
					
					// Second Price, Header Group
					if ($method == 3 ) {
						$o .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
					} else {
						$o .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 3 );
					}
					// END SP
					
					for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
						// item must belong to own group
						if ($data['group'][$g]->id == $data['item'][$i]->catid) {
						
							// Possible tasks in multipleedit - display them only before first row
							if ($method == 3 && $displayTaskIcons == 0) {						
								$o .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
								// there is some first row
								$displayTaskIcons 	= 1;
								$displayAddRow		= 1;
							}
						
							$image	= $tag['spaceimg'];
							// PHOCAGALLERY Image  - - - - - -
							if ((int)$tmpl['phocagallery'] == 1) {
								$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid, $data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth);	
							}
							// - - - - - - - - - - - - - - - - 
						
							if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
								$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
								$pricePref	= $tmpl['priceprefix'];
							} else {
								$price 		= '';
								$pricePref	= '';
							}
							
							// Second Price
							if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
								$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
								$pricePref2		= $tmpl['priceprefix'];
							} else {
								$price2 		= '';
								$pricePref2		= '';
							}
							// End SP
							
							if ($method == 3) {
								$o .= PhocaMenuRenderViews::renderFormItemME(3, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							} else if ($method == 6) {
								$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							} else {
								$o .=PhocaMenuRenderViews::renderFormItem(3, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
							}
						}
					}
					
					$o .= $tag['tableitem-c'] . $tag['item-c'];
					if ($method == 3) {
						if ($displayAddRow == 1) {
							$o .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 3); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
						}			
					}
				} // end items
				
				if ($method == 3) {
					$o .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];
				} else {
					if ($paramsC['displaygroupmsg'] == 2) {
						$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
					}
				}
			
			}
		} // end group
		
		if ($method == 3 && $oddEvenBox == 1) {
			$o .= $tag['bothbox-c'];
		}

		// FOOTER (Config)
		if (isset($data['config'])) {
			$o .=  $tag['footer-o'] . $data['config']->footer .  $tag['footer-c'];
		}
		
		$o .= '</div>';// end phocamenu
		
		if ($method == 3) {
			return $o;
		} else if ($method == 6) {
			return PhocaMenuRenderViews::renderFormCompleteRE($oP);
		}
		
		$enableBBCode = $params->get( 'enable_bb_code', 0 );
		if ((int)$enableBBCode == 1) {
			$o = PhocaMenuHelper::bbCodeReplace($o);
			$o = str_replace ( '[br]', '<br />', $o );
		} else if ((int)$enableBBCode  == 2) {
			$o = str_replace ( '[br]', '<br />', $o );
		}
		$o = PhocaMenuHelper::replaceTag($o, $method);
		
		// Remove empty table - because of TCPDF
		$o = str_replace($tag['tableitem-o'].$tag['tableitem-c'], '', $o);
		return $o;
	}
	
	
	/*
	 *
	 *
	 * Beverage List
	 *
	 *
	 */
	public static function renderBeverageList($data, $tmpl, $params, $paramsG, $method = 0) {
	
		
		$method = self::setMethod($params, $method);
		
		//Frontend params
		$paramsF['displaylistname']	= $params->get('displaylistname', 1);
		$paramsC['displaygroupmsg']	= $params->get( 'display_group_message', 2 );
		$tag = PhocaMenuRenderViews::getStyle($method, $tmpl['phocagallery'], '-bl');
		
		$oP = array();
		
		$o = self::setMainId($method);

		// HEADER (Config)
		if (isset($data['config'])) {
			$o .= $tag['header-o'] . $data['config']->header . $tag['header-c'];
		}

		$right	= '';
		$left	= '';
		// BODY
		
		if (isset($data['list'])) {
			for ($l = 0, $li = count($data['list']); $l < $li; $l++) {
				
				$oddEvenBox = 0;
				if ($method == 3) {
					if ($l%2==0) {
						$o .= $tag['evenbox-o'];
					} else {
						$o .= $tag['oddbox-o'];
					}
					$oddEvenBox = 1;
				}

				if ($method == 3) {	
					$o .= $tag['list-o'] . '<input size="30" type="text" name="list:'.$data['list'][$l]->id.'" id="list:'.$data['list'][$l]->id.'" value="'.$data['list'][$l]->title.'" />' . $tag['list-c'];
				}  else if ($method == 6) {
					$oP[] = '##'.$data['list'][$l]->title;
				} else {
					$o .= '<div style="clear:both"></div>';
					if ($paramsF['displaylistname'] == 1) {
						$o .= $tag['list-o'] . $data['list'][$l]->title . $tag['list-c'];
					}
				}
	
				$col = 0;//column, there are two columns - left | right
				if (isset($data['group'])) {
					for ($g = 0, $gr = count($data['group']); $g < $gr; $g++) {
						
						// group must belong to own list
						if ($data['list'][$l]->id == $data['group'][$g]->catid) {
							
							$col++;
							//right column
							if ($col%2 == 0) {
								
								if ($method == 3) {
									$right .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
								
								}  else if ($method == 6) {
									$oP[] = '###'.$data['group'][$g]->title;
									$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
									if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
								} else {
									$right .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
									if ($paramsC['displaygroupmsg'] == 1) {
										$right .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
									}
								}
														
								if (isset($data['item'])) {
									$displayTaskIconsR 	= 0;
									$displayAddRowR		= 0;
									$right .= $tag['item-o'] . $tag['tableitem-o'];

									// Second Price, Header Group
									if ($method == 3 ) {
										$right .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
									} else {
										$right .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 4 );
									}
									// END SP
					
									for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
										
										// item must belong to own group
										if ($data['group'][$g]->id == $data['item'][$i]->catid) {
										
											// Possible tasks in multipleedit - display them only before first row
											if ($method == 3 && $displayTaskIconsR == 0) {						
												$right .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
												// there is some first row
												$displayTaskIconsR 	= 1;
												$displayAddRowR		= 1;
											}
										
											$image	= $tag['spaceimg'];
											// PHOCAGALLERY Image  - - - - - -
											if ((int)$tmpl['phocagallery'] == 1) {
												$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid, $data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth);	
											}
											// - - - - - - - - - - - - - - - - 
										
											if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
												$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
												$pricePref	= $tmpl['priceprefix'];
											} else {
												$price 		= '';
												$pricePref	= '';
											}
											
											// Second Price
											if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
												$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
												$pricePref2		= $tmpl['priceprefix'];
											} else {
												$price2 		= '';
												$pricePref2		= '';
											}
											// End SP
											
											if ($method == 3) {
												$right .= PhocaMenuRenderViews::renderFormItemME(4, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
											} else if ($method == 6) {
												$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
											} else {
												$right .=PhocaMenuRenderViews::renderFormItem(4, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price, '-bl');
											}

										}
									}
									
									$right .= $tag['tableitem-c'] . $tag['item-c'];
									if ($method == 3) {
										if ($displayAddRowR == 1) {
											$right .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 4); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
										}
									}
								} // end items
								
								if ($method == 3) {
									$right .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];	
								} else {
									if ($paramsC['displaygroupmsg'] == 2) {
										$right .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
									}
								}
								
							//left column
							} else {
								
								if ($method == 3) {
									$left .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
								
								}  else if ($method == 6) {
									$oP[] = '###'.$data['group'][$g]->title;
									if (!empty($data['group'][$g]->message)) {
										$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
										if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
									}
								} else {
									$left .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
									if ($paramsC['displaygroupmsg'] == 1) {
										$left .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
									}									
								}
													
								if (isset($data['item'])) {
									$displayTaskIconsL 	= 0;
									$displayAddRowL		= 0;
									$left .= $tag['item-o'] . $tag['tableitem-o'];

									// Second Price, Header Group
									if ($method == 3 ) {
										$left .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
									} else {
										$left .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 4 );
									}
									// END SP
											
									for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
										
										// item must belong to own group
										if ($data['group'][$g]->id == $data['item'][$i]->catid) {
										
											// Possible tasks in multipleedit - display them only before first row
											if ($method == 3 && $displayTaskIconsL == 0) {						
												$left .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
												// there is some first row
												$displayTaskIconsL 	= 1;
												$displayAddRowL		= 1;
											}
										
											$image	= $tag['spaceimg'];
											// PHOCAGALLERY Image  - - - - - -
											if ((int)$tmpl['phocagallery'] == 1) {
												$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid, $data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth);	
											}
											// - - - - - - - - - - - - - - - - 
										
											if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
												$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
												$pricePref	= $tmpl['priceprefix'];
											} else {
												$price 		= '';
												$pricePref	= '';
											}
											
											// Second Price
											if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
												$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
												$pricePref2		= $tmpl['priceprefix'];
											} else {
												$price2 		= '';
												$pricePref2		= '';
											}
											// End SP
											
											if ($method == 3) {
												$left .= PhocaMenuRenderViews::renderFormItemME(4, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
											} else if ($method == 6) {
												$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
											} else {
												$left .=PhocaMenuRenderViews::renderFormItem(4, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price, '-bl');
											}
											
										}
									}
									
									$left .= $tag['tableitem-c'] . $tag['item-c'];
									if ($method == 3) {
										if ($displayAddRowL == 1) {
											$left .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 4); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
										}
									}
								} // end items
								
								if ($method == 3) {
									$left .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];	
								} else {
									if ($paramsC['displaygroupmsg'] == 2) {
										$left .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
									}
								}
							}
						}
					}	
				} // end group
				
				$o .= $tag['groupleft-o'] . $left .  $tag['groupleft-c'];
				$o .= $tag['groupright-o'] . $right .  $tag['groupright-c'];
				$left 	= '';
				$right 	= '';
				
				if ($method == 3 && $oddEvenBox == 1) {
					$o .= $tag['bothbox-c'];
				}
			}
			
			$o .= '<div style="clear:both"></div>';
		}

		// FOOTER (Config)
		if (isset($data['config'])) {
			$o .=  $tag['footer-o'] . $data['config']->footer .  $tag['footer-c'];
		}

		$o .= '</div>';// end phocamenu
		if ($method == 3) {
			return $o;
		} else if ($method == 6) {
			return PhocaMenuRenderViews::renderFormCompleteRE($oP);
		}
		
		$enableBBCode = $params->get( 'enable_bb_code', 0 );
		if ((int)$enableBBCode == 1) {
			$o = PhocaMenuHelper::bbCodeReplace($o);
			$o = str_replace ( '[br]', '<br />', $o );
		} else if ((int)$enableBBCode  == 2) {
			$o = str_replace ( '[br]', '<br />', $o );
		}
		$o = PhocaMenuHelper::replaceTag($o, $method);
		
		// Remove empty table - because of TCPDF
		$o = str_replace($tag['tableitem-o'].$tag['tableitem-c'], '', $o);
		
		//echo $o;exit;
		return $o;
	}
	
	
	/*
	 *
	 *
	 * Common List Menu - Food Menu Wine List
	 *
	 *
	 */
	public static function renderCommonListMenu($data, $tmpl, $params, $paramsG, $method = 0) {
	
		$method = self::setMethod($params, $method);
		//Frontend params
		$paramsF['displaylistname']	= $params->get('displaylistname',1);
		$paramsC['displaygroupmsg']	= $params->get( 'display_group_message', 2 );
		
		$tag = PhocaMenuRenderViews::getStyle($method, $tmpl['phocagallery'], '-clm');

		$oP = array();
		
		$o = self::setMainId($method);
		// HEADER (Config)
		
		if (isset($data['config'])) {
			$o .= $tag['header-o'] . $data['config']->header . $tag['header-c'];
		}

		// BODY
		
		if (isset($data['list'])) {
			for ($l = 0, $la = count($data['list']); $l < $la; $l++) {
			
				$oddEvenBox = 0;
				if ($method == 3) {
					if ($l%2==0) {
						$o .= $tag['evenbox-o'];
					} else {
						$o .= $tag['oddbox-o'];
					}
					$oddEvenBox = 1;
				}
			
				if ($method == 3) {			
					$o .= $tag['list-o'] . '<input size="30" type="text" name="list['.$data['list'][$l]->id.']" id="list'.$data['group'][$l]->id.'" value="'.$data['list'][$l]->title.'" />' . $tag['list-c'];
				}  else if ($method == 6) {
					$oP[] = '##'.$data['list'][$l]->title;
				} else {
					if ($paramsF['displaylistname']	== 1) {
						$o .= $tag['list-o'] . $data['list'][$l]->title . $tag['list-c'];
					}
				}
								
				if (isset($data['group'])) {
					for ($g = 0, $gr = count($data['group']); $g < $gr; $g++) {
						// group must belong to own day
						if ($data['list'][$l]->id == $data['group'][$g]->catid) {
							
							if ($method == 3) {
								$o .= $tag['group-o'] . '<input size="30" type="text" name="group['.$data['group'][$g]->id.']" id="group'.$data['group'][$g]->id.'" value="'.$data['group'][$g]->title.'" />' . $tag['group-c'];
								//$o .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];
							
							}  else if ($method == 6) {
								$oP[] = '###'.$data['group'][$g]->title;
								if (!empty($data['group'][$g]->message)) {
									$groupMsg = PhocaMenuHelper::cleanRawOutput($data['group'][$g]->message);
									if (!empty($groupMsg)) {$oP[] = '>'.$groupMsg;}
								}
							} else {
								$o .= $tag['group-o'] . $data['group'][$g]->title . $tag['group-c'];
								if ($paramsC['displaygroupmsg'] == 1) {
									$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
								}
							}
							
							if (isset($data['item'])) {
							
								$displayTaskIcons 	= 0;
								$displayAddRow		= 0;
								
								$o .= $tag['item-o'] . $tag['tableitem-o'];

								// Second Price, Header Group
								if ($method == 3 ) {
									$o .= PhocaMenuRenderViews::renderGroupHeaderME($data['group'][$g], $tag );
								} else {
									$o .= PhocaMenuRenderViews::renderGroupHeader($data['group'][$g]->display_second_price, $data['group'][$g]->header_price, $data['group'][$g]->header_price2, $tag, $method, 5 );
								}
								// END SP
					
								for ($i = 0, $it = count($data['item']); $i < $it; $i++) {
									
									// item must belong to own group
									if ($data['group'][$g]->id == $data['item'][$i]->catid) {
										
										// Possible tasks in multipleedit - display them only before first row
										if ($method == 3 && $displayTaskIcons == 0) {						
											$o .= PhocaMenuRenderViews::renderTaskIconsME($data['group'][$g]->display_second_price);
											// there is some first row
											$displayTaskIcons 	= 1;
											$displayAddRow		= 1;
										}
									
										$image	= $tag['spaceimg'];
										// PHOCAGALLERY Image  - - - - - -
										if ((int)$tmpl['phocagallery'] == 1) {
											$image = PhocaMenuGallery::getPhocaGalleryLink($tmpl['imagesize'], $data['item'][$i]->imageid, $data['item'][$i]->imagefilename, $data['item'][$i]->imagecatid, $data['item'][$i]->imageslug, $data['item'][$i]->imagecatslug, $paramsG['imagedetailwindow'], $tmpl['button'], $data['item'][$i]->imageextid,$data['item'][$i]->imageexts,$data['item'][$i]->imageextm,$data['item'][$i]->imageextl,$data['item'][$i]->imageextw,$data['item'][$i]->imageexth);	
										}
										// - - - - - - - - - - - - - - - - 
									
										if (isset($data['item'][$i]->price) && $data['item'][$i]->price > 0) {
											$price 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price, $params);
											$pricePref	= $tmpl['priceprefix'];
										} else {
											$price 		= '';
											$pricePref	= '';
										}
										
										// Second Price
										if ($data['group'][$g]->display_second_price == 1 && isset($data['item'][$i]->price2) && $data['item'][$i]->price2 > 0) {
											$price2 		= PhocaMenuHelper::getPriceFormat($data['item'][$i]->price2, $params);
											$pricePref2		= $tmpl['priceprefix'];
										} else {
											$price2 		= '';
											$pricePref2		= '';
										}
										// End SP

										if ($method == 3) {
											$o .= PhocaMenuRenderViews::renderFormItemME(5, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
										} else if ($method == 6) {
											$oP[] = PhocaMenuRenderViews::renderFormItemRE(1, $tag, $data['group'][$g], $data['item'][$i], $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price);
										} else {
											$o .=PhocaMenuRenderViews::renderFormItem(5, $tag, $image, $data['item'][$i], $price, $pricePref, $method, $price2, $pricePref2, $data['group'][$g]->display_second_price, '-clm');
										}
									}
								}
								$o .= $tag['tableitem-c'] . $tag['item-c'];
								if ($method == 3) {
									if ($displayAddRow == 1) {
										$o .= '<div class="pm-addrow"><small><a href="#" onclick="addRow('.$data['group'][$g]->id.', 5); return false;">'.JText::_('COM_PHOCAMENU_ADD_ROW').'</a></small></div>';
									}
								}								
							} //end items
							
							if ($method == 3) {
								$o .= $tag['message-o'] . '<textarea rows="2" cols="60" name="message[' . $data['group'][$g]->id .']" id="message' . $data['group'][$g]->id .'">'. $data['group'][$g]->message . '</textarea>'. $tag['message-c'];
							
							} else {
								if ($paramsC['displaygroupmsg'] == 2) {
									$o .= $tag['message-o'] .  $data['group'][$g]->message . $tag['message-c'];
								}
							}
						}
					}
				} // end group
				
				if ($method == 3 && $oddEvenBox == 1) {
					$o .= $tag['bothbox-c'];
				}
			}
		}

		// FOOTER (Config)
		if (isset($data['config'])) {
			$o .=  $tag['footer-o'] . $data['config']->footer .  $tag['footer-c'];
		}

		$o .= '</div>';// end phocamenu
		
		if ($method == 3) {
			return $o;
		} else if ($method == 6) {
			return PhocaMenuRenderViews::renderFormCompleteRE($oP);
		}
		
		$enableBBCode = $params->get( 'enable_bb_code', 0 );
		if ((int)$enableBBCode == 1) {
			$o = PhocaMenuHelper::bbCodeReplace($o);
			$o = str_replace ( '[br]', '<br />', $o );
		} else if ((int)$enableBBCode  == 2) {
			$o = str_replace ( '[br]', '<br />', $o );
		}
		$o = PhocaMenuHelper::replaceTag($o, $method);
		
		// Remove empty table - because of TCPDF
		$o = str_replace($tag['tableitem-o'].$tag['tableitem-c'], '', $o);
		return $o;
	}
	
	
	public static function getStyle($method, $phocaGallery, $suffix = '') {
	
		// 2 means, there are two prices, all the table tds must be recalculated, e.g. $tag['desc2-c'] - this is not a method
		switch ($method) {
			
			// Email
			case 1:
				$tag['header-o']		= '<div style="font-size:140%;font-weight:bold;margin:10px">';
				$tag['header-c']		= '</div>';
				$tag['date-o']			= '<div style="font-size:120%;font-weight:bold;margin:10px;text-align:right;">';
				$tag['date-c']			= '</div>';
				$tag['datesub-o']		= '<div style="font-size:110%;font-weight:bold;margin:10px;margin-top:20px;text-decoration:underline">';
				$tag['datesub-c']		= '</div>';
				$tag['list-o']			= '<div style="font-weight:bold;margin:10px;">';
				$tag['list-c']			= '</div>';
				$tag['group-o']			= '<div style="font-weight:bold;margin:10px;">';
				$tag['group-c']			= '</div>';
				$tag['groupleft-o']		= '<div style="overflow:visible;position:relative;float:left;width:43%;margin:1% 2% 1% 1%;">';
				$tag['groupleft-c']		= '</div>';
				$tag['groupright-o']	= '<div style="overflow:visible;position:relative;float:right;width:43%;margin:1% 1% 1% 2%;">';
				$tag['groupright-c']	= '</div>';
				$tag['item-o']			= '<div style="margin:10px;width:100%">';
				$tag['item-c']			= '</div>';
				$tag['tableitem-o']		= '<table width="90%" cellspacing="3" cellpadding="3" style="border:0px;border-collapse:collapse;">';
				$tag['tableitem-c']		= '</table>';
				
				if ($suffix == '-clm') {
					$tag['message-o']		= '<div style="text-align:left">';
				} else {
					$tag['message-o']		= '<div style="text-align:center">';
				}
				$tag['message-c']		= '</div>';
				
				$tag['image-o']			= '<td class="pmimage">';
				$tag['image-rs-o']		= '<td class="pmimage" ';//Not closed - waiting for rowspan
				$tag['image-c']			= '</td>';
				
				if ((int)$phocaGallery == 1) {
					$tag['quantity-o']		= '<td style="vertical-align:middle;width:8%;white-space:nowrap;">';
					if ($suffix == '-clm') {
						$tag['title-o']		= $tag['title2-o']	= '<td style="vertical-align:middle;width:auto;font-weight:bold">';
					} else {
						$tag['title-o']		= $tag['title2-o']	= '<td style="vertical-align:middle;width:auto;">';
					}
					$tag['priceprefix-o']	= '<td style="vertical-align:middle;width:2%">';
					$tag['price-o']			= '<td style="vertical-align:middle;width:5%;white-space:nowrap;padding-left: 10px;">';
					$tag['price2-o']		= '<td style="vertical-align:middle;width:5%;white-space:nowrap;padding-left: 10px;">';
				} else {
					$tag['quantity-o']		= '<td style="width:8%;white-space:nowrap;">';
					if ($suffix == '-clm') {
						$tag['title-o']		= $tag['title2-o']	= '<td style="vertical-align:middle;width:auto;font-weight:bold">';
					} else {
						$tag['title-o']		= $tag['title2-o']	= '<td style="vertical-align:middle;width:auto;">';
					}
					
					$tag['priceprefix-o']	= '<td style="width:2%">';
					$tag['price-o']			= '<td style="width:5%;white-space:nowrap;padding-left: 10px;">';
					$tag['price2-o']		= '<td style="width:5%;white-space:nowrap;padding-left: 10px;">';
				}
				$tag['quantity-c']		= '</td>';
				$tag['title-c']			= '</td>';
				$tag['title2-c']		= '</td>';
				$tag['priceprefix-c']	= '</td>';
				$tag['price-c']			= '</td>';
				$tag['price2-c']		= '</td>';
				
				
				$tag['desc-o']			= $tag['desc2-o'] = '<td style="font-style:italic;margin:5px">';
				$tag['desc-c']			= $tag['desc2-c'] = '</td>';
				
				$tag['groupheader1-o']			= '<td align="right">';
				$tag['groupheader1-c']			= '</td>'. "\n";
				$tag['groupheader2-o']			= '<td align="right" >';
				$tag['groupheader2-c']			= '</td>'. "\n";
				
				
				
				$tag['footer-o']		= '<div class="pm-footer">';
				$tag['footer-c']		= '</div>';
				
				$tag['space']			= '&nbsp;';
				$tag['spaceimg']		= '&nbsp;';
			
				
			break;
			
			//PDF
			case 2:
			
				$tag['header-o']		= '<div>';
				$tag['header-c']		= '</div>';
				$tag['date-o']			= '<p style="font-weight: bold;font-size: x-large;text-align: right;">';
				$tag['date-c']			= '</p>';
				$tag['datesub-o']		= '<p style="font-weight: bold;font-size: large;text-decoration: underline">';
				$tag['datesub-c']		= '</p>';
				$tag['list-o']			= '<p style="font-weight: bold;font-size: large;text-decoration: underline">';
				$tag['list-c']			= '</p>';
				$tag['group-o']			= '<p style="font-weight:bold;font-size:x-large;">';
				$tag['group-c']			= '</p>';
				
				$tag['item-o']			= '<div>';
				$tag['item-c']			= '</div>';
				$tag['tableitem-c']		= '</table>';
				$tag['message-o']		= '<table border="0"><tr><td>';
				$tag['message-c']		= '<br /></td></tr></table>';
				
				$tag['image-o']			= '<td width="2pt">';
				$tag['image-rs-o']		= '<td width="2pt" ';//Not closed - waiting for rowspan
				$tag['image-c']			= '</td>';
				
				if ($suffix == '-bl') {
					
					$tag['tableitem-o']		= '<table border="0" cellpadding="0"  >';
					
					$tag['groupleft-o']		= '<table border="0"><tr><td width="245pt">';
					$tag['groupleft-c']		= '</td>';
					$tag['groupright-o']	= '<td width="20pt">&nbsp;</td><td width="245pt">';
					$tag['groupright-c']	= '</td></tr></table>';
					
					$tag['quantity-o']		= '<td width="40pt" style="text-align:right">';
					$tag['title-o']			= '<td width="138pt" >&nbsp;';
					$tag['title2-o']		= '<td width="88pt" >&nbsp;';//Second Price
					$tag['priceprefix-o']	= '<td width="17pt" style="text-align:right;">';
					$tag['price-o']			= $tag['price2-o'] =  '<td width="50pt" style="text-align:right;">';
					
				} else if($suffix == '-clm') {
					
					$tag['tableitem-o']		= '<table border="0" cellpadding="1" >';
					
					$tag['quantity-o']		= '<td width="50pt" style="text-align:right">';
					$tag['title-o']			= '<td width="386pt" style="font-weight:bold;font-size:large;">';
					$tag['title2-o']		= '<td width="336pt" style="font-weight:bold;font-size:large;">';//Second Price
					$tag['priceprefix-o']	= '<td width="22pt" style="text-align:right;">';
					$tag['price-o']			= $tag['price2-o'] =  '<td width="50pt" style="text-align:right;">';
				
				} else {
					
					$tag['tableitem-o']		= '<table border="0" cellpadding="1">';
					
					$tag['quantity-o']		= '<td width="50pt" style="text-align:right">';
					$tag['title-o']			= '<td width="386pt">';
					$tag['title2-o']		= '<td width="336pt">';//Second Price
					$tag['priceprefix-o']	= '<td width="22pt" style="text-align:right;">';
					$tag['price-o']			= $tag['price2-o'] = '<td width="50pt" style="text-align:right;">';
				}
				
				$tag['quantity-c']		= '</td>';
				$tag['title-c']			= '</td>';
				$tag['title2-c']		= '</td>';
				$tag['priceprefix-c']	= '</td>';
				$tag['price-c']			= '</td>';
				$tag['price2-c']		= '</td>'. "\n";
				
				$tag['groupheader1-o']			= '<td width="50pt" style="text-align:right;">';
				$tag['groupheader1-c']			= '</td>'. "\n";
				$tag['groupheader2-o']			= '<td width="50pt" style="text-align:right;">';
				$tag['groupheader2-c']			= '</td>'. "\n";
				
				if ($suffix == '-bl') {
					$tag['desc-o']			= '<td width="192pt" style="font-style:italic;">';
					$tag['desc2-o']			= '<td width="142pt" style="font-style:italic;">';// Second Price
				} else {
					$tag['desc-o']			= '<td width="386pt" style="font-style:italic;">';
					$tag['desc2-o']			= '<td width="336pt" style="font-style:italic;">';// Second Price
				}
				$tag['desc-c']			= '</td>';
				$tag['desc2-c']			= '</td>';
				
				$tag['footer-o']		= '<table border="0"><tr><td>';
				$tag['footer-c']		= '</td></tr></table>';
			
				$tag['space']			= '&nbsp;';
				$tag['spaceimg']		= '';
				
			break;
			
			// Bootstrap 2 (Frontend)
			case 4:
			
				$tag['header-o']		= '<div class="pm-header">';
				$tag['header-c']		= '</div>'. "\n";
				$tag['date-o']			= '<div class="pm-date">';
				$tag['date-c']			= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['datesub-o']		= '<div class="pm-date-sub">';
				$tag['datesub-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['list-o']			= '<div class="pm-list">';
				$tag['list-c']			= '</div>'. "\n";
				$tag['group-o']			= '<div class="row row-fluid pm-group">';
				$tag['group-c']			= '</div>'. "\n";
				$tag['evenbox-o']		= '<div class="row row-fluid">';
				$tag['oddbox-o']		= '<div class="row row-fluid">';
				$tag['groupleft-o']		= '<div class="span6 pm-group-left-bs">';
				$tag['groupleft-c']		= '</div>'. "\n";
				$tag['groupright-o']	= '<div class="span6 pm-group-right-bs">';
				$tag['groupright-c']	= '</div>'. "\n";
				$tag['item-o']			= '';
				$tag['item-c']			= ''. "\n";
				$tag['tableitem-o']		= '';
				$tag['tableitem-c']		= ''. "\n";
				$tag['message-o']		= '<div class="pm-message">';
				$tag['message-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				// Tag TITLE AND TAG DESCRIPTION IS COUNTED BELOW 

				$tag['row-box-o']		= '<div class="ph-item-row-box">';
				$tag['row-box-c']		= '</div>';
				$tag['row-o']			= '<div class="row row-fluid pm-item-row">';
				$tag['row-c']			= '</div>';
				$tag['row-desc-o']		= '<div class="row row-fluid pm-desc-row">';
				$tag['row-desc-c']		= '</div>';
				$tag['row-group-h-o']	= '<div class="row row-fluid pm-group-header-row">';
				$tag['row-group-h-c']	= '</div>';
				
				$tag['image-o']			= '<div class="span2 pmimage">';
				$tag['quantity-o']		= '<div class="span1 pmquantity">';
				$tag['priceprefix-o']	= '<div class="span1 pmpriceprefix pm-right">';
				
				$tag['price-o-span2']	= '<div class="span2 pmprice pm-right">';
				$tag['price-o-span1']	= '<div class="span1 pmprice pm-right">';
				
				
				$tag['groupheader1-o-span1']	= '<div class="span1 pmgroupheader1">';
				$tag['groupheader1-o-span2']	= '<div class="span2 pmgroupheader1">';
				$tag['groupheader2-o-span1']	= '<div class="span1 pmgroupheader2">';
				$tag['groupheader2-o-span2']	= '<div class="span2 pmgroupheader2">';
				
				$tag['image-c']			= '</div>'. "\n";
				$tag['quantity-c']		= '</div>'. "\n";
				$tag['priceprefix-c']	= '</div>'. "\n";
				$tag['price-c']			= '</div>'. "\n";
				
				$tag['groupheader1-c']	= '</div>'. "\n";
				$tag['groupheader2-c']	= '</div>'. "\n";


				
				$tag['footer-o']		= '<div class="pm-footer">';
				$tag['footer-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				$tag['space']			= '&nbsp;';
				$tag['spaceimg']		= '&nbsp;';

			break;
			
			// Bootstrap 3 (Frontend)
			case 5:
			
				$tag['header-o']		= '<div class="pm-header">';
				$tag['header-c']		= '</div>'. "\n";
				$tag['date-o']			= '<div class="pm-date">';
				$tag['date-c']			= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['datesub-o']		= '<div class="pm-date-sub">';
				$tag['datesub-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['list-o']			= '<div class="pm-list">';
				$tag['list-c']			= '</div>'. "\n";
				$tag['group-o']			= '<div class="row row-fluid pm-group">';
				$tag['group-c']			= '</div>'. "\n";
				$tag['evenbox-o']		= '<div class="row row-fluid">';
				$tag['oddbox-o']		= '<div class="row row-fluid">';
				$tag['groupleft-o']		= '<div class="col-xs-12 col-sm-6 col-md-6 pm-group-left-bs">';
				$tag['groupleft-c']		= '</div>'. "\n";
				$tag['groupright-o']	= '<div class="col-xs-12 col-sm-6 col-md-6 pm-group-right-bs">';
				$tag['groupright-c']	= '</div>'. "\n";
				$tag['item-o']			= '';
				$tag['item-c']			= ''. "\n";
				$tag['tableitem-o']		= '';
				$tag['tableitem-c']		= ''. "\n";
				$tag['message-o']		= '<div class="pm-message">';
				$tag['message-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				// Tag TITLE AND TAG DESCRIPTION IS COUNTED BELOW 

				$tag['row-box-o']		= '<div class="ph-item-row-box">';
				$tag['row-box-c']		= '</div>';
				$tag['row-o']			= '<div class="row row-fluid pm-item-row">';
				$tag['row-c']			= '</div>';
				$tag['row-desc-o']		= '<div class="row row-fluid pm-desc-row">';
				$tag['row-desc-c']		= '</div>';
				$tag['row-group-h-o']	= '<div class="row row-fluid pm-group-header-row">';
				$tag['row-group-h-c']	= '</div>';
				
				$tag['image-o']			= '<div class="col-xs-12 col-sm-2 col-md-2 pmimage">';
				$tag['quantity-o']		= '<div class="col-xs-12 col-sm-1 col-md-1 pmquantity">';
				$tag['priceprefix-o']	= '<div class="col-xs-12 col-sm-1 col-md-1 pmpriceprefix pm-right">';
				
				$tag['price-o-span2']	= '<div class="col-xs-12 col-sm-2 col-md-2 pmprice pm-right">';
				$tag['price-o-span1']	= '<div class="col-xs-12 col-sm-1 col-md-1 pmprice pm-right">';
				
				
				$tag['groupheader1-o-span1']	= '<div class="col-xs-12 col-sm-1 col-md-1 pmgroupheader1">';
				$tag['groupheader1-o-span2']	= '<div class="col-xs-12 col-sm-2 col-md-2 pmgroupheader1">';
				$tag['groupheader2-o-span1']	= '<div class="col-xs-12 col-sm-1 col-md-1 pmgroupheader2">';
				$tag['groupheader2-o-span2']	= '<div class="col-xs-12 col-sm-2 col-md-2 pmgroupheader2">';
				
				$tag['image-c']			= '</div>'. "\n";
				$tag['quantity-c']		= '</div>'. "\n";
				$tag['priceprefix-c']	= '</div>'. "\n";
				$tag['price-c']			= '</div>'. "\n";
				
				$tag['groupheader1-c']	= '</div>'. "\n";
				$tag['groupheader2-c']	= '</div>'. "\n";


				
				$tag['footer-o']		= '<div class="pm-footer">';
				$tag['footer-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				$tag['space']			= '&nbsp;';
				$tag['spaceimg']		= '&nbsp;';

			break;
			
	

			
			// Multiple Edit
			case 3:
			// Raw Edit
			case 6:
			// Front Table
			default:
			
				$tag['header-o']		= '<div class="pm-header">';
				$tag['header-c']		= '</div>'. "\n";
				$tag['date-o']			= '<div class="pm-date">';
				$tag['date-c']			= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['datesub-o']		= '<div class="pm-date-sub">';
				$tag['datesub-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['list-o']			= '<div class="pm-list">';
				$tag['list-c']			= '</div>'. "\n";
				$tag['group-o']			= '<div class="pm-group">';
				$tag['group-c']			= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['groupleft-o']		= '<div class="pm-group-left">';
				$tag['groupleft-c']		= '</div><div class="cr"></div>'. "\n";
				$tag['groupright-o']	= '<div class="pm-group-right">';
				$tag['groupright-c']	= '</div><div class="cl"></div>'. "\n";
				$tag['item-o']			= '<div class="pm-item' .$suffix. '">';
				$tag['item-c']			= '</div>'. "\n";
				$tag['tableitem-o']		= '<table style="border:0px;">';
				$tag['tableitem-c']		= '</table><div class="clearfix ph-clearfix"></div>'. "\n";
				$tag['message-o']		= '<div class="pm-message">';
				$tag['message-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				$tag['image-o']			= '<td class="pmimage">';
				$tag['image-rs-o']		= '<td class="pmimage" ';//Not closed - waiting for rowspan
				$tag['image-c']			= '</td>'. "\n";
				
				if ((int)$phocaGallery == 1) {
					$tag['quantity-o']		= '<td class="pmquantity" style="vertical-align:middle">';
					$tag['title-o']			= '<td class="pmtitle" style="vertical-align:middle">';
					$tag['title2-o']		= '<td class="pmtitle2" style="vertical-align:middle">';
					$tag['priceprefix-o']	= '<td class="pmpriceprefix" style="vertical-align:middle">';
					$tag['price-o']			= '<td class="pmprice" style="vertical-align:middle">';
					$tag['price2-o']		= '<td class="pmprice2" style="vertical-align:middle">';
				} else {
					$tag['quantity-o']		= '<td class="pmquantity">';
					$tag['title-o']			= '<td class="pmtitle">';
					$tag['title2-o']		= '<td class="pmtitle2">';
					$tag['priceprefix-o']	= '<td class="pmpriceprefix">';
					$tag['price-o']			= '<td class="pmprice">';
					$tag['price2-o']		= '<td class="pmprice2">';
				}
				$tag['quantity-c']		= '</td>'. "\n";
				$tag['title-c']			= '</td>'. "\n";
				$tag['title2-c']		= '</td>'. "\n";
				$tag['priceprefix-c']	= '</td>'. "\n";
				$tag['price-c']			= '</td>'. "\n";
				$tag['price2-c']		= '</td>'. "\n";
				
				$tag['desc-o']			= $tag['desc2-o'] = '<td class="pmdesc">';
				$tag['desc-c']			= $tag['desc2-c'] = '</td>'. "\n";
				
				$tag['groupheader1-o']			= '<td class="pmgroupheader1">';
				$tag['groupheader1-c']			= '</td>'. "\n";
				$tag['groupheader2-o']			= '<td class="pmgroupheader2">';
				$tag['groupheader2-c']			= '</td>'. "\n";
				
				
				$tag['footer-o']		= '<div class="pm-footer">';
				$tag['footer-c']		= '</div><div class="clearfix ph-clearfix"></div>'. "\n";
				
				$tag['space']			= '&nbsp;';
				$tag['spaceimg']		= '&nbsp;';
				
				if ($method == 3) {
					$tag['evenbox-o']		= '<div class="pmeven">';
					$tag['oddbox-o']		= '<div class="pmodd">';
					$tag['bothbox-c']		= '</div>';
					$tag['date-c']			= '</div><div style="clear:both"></div>';
					$tag['groupleft-o']		= '<div class="pm-group">';// no float
					$tag['groupright-o']	= '<div class="pm-group">';// no float
				}
			break;
		}
		return $tag;
	}

	
	
	public static function renderFormItem($type, $tag, $image, $itemObject, $price, $pricePref, $method, $price2, $pricePref2, $displaySecondPrice, $suffix = '') {
		
		
		// Image
		$noImage = 1;
		if($image == '' || $image == '&nbsp;') {
			$noImage = 1;
		} else {
			$noImage = 0;
		}
		
		// If there is second price, add the prefix before both prices
		if ($price == '') {
			// Seems, there is no price but maybe there is second price
			if ($displaySecondPrice == 1 && $price2 != '') {
				$pricePref = $pricePref2;
			}
		}
		
		
		$rowSpan 	= '';
		$descRow 	= '';
		$row 		= array();
		$desc		= array();
	
		if ($method == 4 || $method == 5) {
			// ============= BOOTSTRAP 2 | BOOTSTRAP 3 =============
		
			$c = 0;
			
			if ($method == 4) {
				$span = 'span';
				$span2 = '';
			} else {
				$span = 'col-xs-12 col-sm-';
				$span2= ' col-md-';
			}

			if($noImage == 1) {
				$row['img'] = '';
				$desc['img']= '';
			} else {
				$row['img'] = $tag['image-o'] . $image . $tag['image-c'];
				$desc['img']= $tag['image-o'] . '' . $tag['image-c'];
				$c = $c + 2;
			}
			
			$row['quantity'] = $tag['quantity-o'] . $itemObject->quantity . $tag['space']  . $tag['quantity-c'];
			$desc['quantity']= $tag['quantity-o'] . '' . $tag['quantity-c'];
			$c = $c + 1;
			
			// Matter of taste - add the priceprefix to first price
			$row['prefix'] = '';
			$desc['prefix'] = '';
			if ($pricePref != '') {
				$row['prefix'] = $tag['priceprefix-o'] . $pricePref. $tag['space'] . $tag['priceprefix-c'];
				$desc['prefix']= $tag['priceprefix-o'] . '' . $tag['priceprefix-c'];
				$c = $c + 1;
			}
			
			// Price
			// Type = 4 - Beverage list - there are two columns so we need to add one column - the header is changed too
			if ($type == 4) {
				$cP = 2;// span2 for price
				$sP = 'price-o-span2';
			} else {
				$cP = 1;// span1 for price
				$sP = 'price-o-span1';
			}
			
			if ($displaySecondPrice == 1) {
				$row['price1'] =  $tag[$sP]  . $price . $tag['price-c'];// REMOVE priceprefix possible
				$desc['price1']=  $tag[$sP] . '' . $tag['price-c'];
				$c = $c + $cP;
				$row['price2'] =  $tag[$sP]  . $price2 . $tag['price-c'];
				$desc['price2']=  $tag[$sP] . '' . $tag['price-c'];
				$c = $c + $cP;
			} else {
				$row['price1'] =  $tag[$sP]  . $price . $tag['price-c'];// REMOVE priceprefix possible
				$desc['price1']=  $tag[$sP] . '' . $tag['price-c'];
				$row['price2'] = '';
				$desc['price2'] = '';
				$c = $c + $cP;
			}
			
			// TITLE
			$titleColumn = 12 - (int)$c;
			
			$pmtitleO = '';
			if ($suffix == '-clm') {
				$pmtitleO = 'pmtitle-clm';
			} else if ($type == 4) {
				$pmtitleO = 'pmtitle-bl';
			}
			
			$row['title'] = '<div class="'.$span.$titleColumn.$span2.$titleColumn.' pmtitle '.$pmtitleO.'">'.$itemObject->title.'</div>';
			
			
			$o = $tag['row-box-o'] . $tag['row-o'] . $row['img'] . $row['quantity'] . $row['title'] . $row['prefix'] . $row['price1'] . $row['price2'] . $tag['row-c'];

			// DESCRIPTION
			if ($itemObject->description != '') {

				$descRow .= $tag['row-desc-o'];
				$descRow .= $desc['img'] . $desc['quantity'];
				$descRow .= '<div class="'.$span.$titleColumn.$span2.$titleColumn.' pmdesc">';
				$descRow .= $itemObject->description;
				$descRow .= '</div>'; 
				$descRow .= $desc['prefix'] . $desc['price1'] . $desc['price2'];
				$descRow .= $tag['row-desc-c'];
			}
			$o = $o . $descRow . $tag['row-box-c'];

			
		} else {
			// ============= TABLE =============
			
			if ($itemObject->description != '') {
				$rowSpan = 'rowspan="2"';
				$descRow = '<tr>'; 
				
				if ($method == 2) {
					$descRow .= $tag['image-o'] . $tag['spaceimg'] . $tag['image-c'];
				}
				
				$descRow .= $tag['quantity-o']  . $tag['space'] . $tag['quantity-c'];
				
				if ($displaySecondPrice == 1) {	
					$descRow.= $tag['desc2-o'] . $itemObject->description . $tag['desc2-c'];
				} else {
					$descRow.= $tag['desc-o'] . $itemObject->description . $tag['desc-c'];
				}
				 
				$descRow .= $tag['priceprefix-o'] . $tag['space'] . $tag['priceprefix-c']
						  . $tag['price-o'] . $tag['space']  . $tag['price-c'];
				if ($displaySecondPrice == 1) {
					$descRow .= $tag['price2-o'] . $tag['space']  . $tag['price2-c'];
				}
				
				
				
				$descRow .= '</tr>';
			}
			
			$o = '<tr>';
			
			if ($method == 2) {
				$o .= $tag['image-o'] . $tag['spaceimg'] . $tag['image-c']; // PDF - no rowspan
			} else {
				if ($itemObject->description != '') {
					$o .= $tag['image-rs-o'] . $rowSpan .'>' . $image . $tag['image-c'];
				} else {
					$o .= $tag['image-o'] . $image . $tag['image-c'];
				}
			}
			
			$o .= $tag['quantity-o'] .$itemObject->quantity . $tag['space'] . $tag['quantity-c'];
			
			if ($displaySecondPrice == 1) {
				$o .= $tag['title2-o'] . $itemObject->title . $tag['title2-c'];
			} else {
				$o .= $tag['title-o'] . $itemObject->title . $tag['title-c'];
			}
			
			if ($displaySecondPrice == 1) {
				$o .= $tag['priceprefix-o'] . $pricePref. $tag['space'] . $tag['priceprefix-c']
				. $tag['price-o'] . $price . $tag['price-c'] ;
				if ($price2 == '') {
					$price2 = $tag['space'];
				} 
				$o .= $tag['price2-o'] .$price2 . $tag['price2-c'];
			} else {
				$o .= $tag['priceprefix-o'] . $pricePref. $tag['space'] . $tag['priceprefix-c']
				. $tag['price-o'] . $price . $tag['price-c'] ;
				
			}
			
			$o .= '</tr>';
			
			// Description
			if ($itemObject->description != '') {
				$o .= $descRow;
			}
		}
				
		
		
		return $o;
	}
	
	
	public static function renderFormItemRE($type, $tag, $groupObject, $itemObject, $pricePref, $method, $price2, $pricePref2, $displaySecondPrice) {
		
		$app			= JFactory::getApplication();
		$paramsC 		= $app->isAdmin() ? JComponentHelper::getParams('com_phocamenu') : $app->getParams();
		$item_delimiter	= $paramsC->get( 'item_delimiter', 1 );
		if ($item_delimiter == 1) {
			$item_delimiter = ";";
		} else {
			$item_delimiter = "\t";
		}
		
		$oPI = array();
		
		$oPI[] = strip_tags(trim($itemObject->quantity));
		$oPI[] = strip_tags(trim($itemObject->title));
		$oPI[] = strip_tags(trim($itemObject->price));
		$oPI[] = strip_tags(trim($itemObject->price2));
		$oPI[] = strip_tags(trim($itemObject->description));
		
		if ($itemObject->imageid == 0) {
			$itemObject->imageid = '';
		}
		$oPI[] = trim($itemObject->imageid);
	
		
		if (!empty($oPI)) {
			
			return implode($item_delimiter, $oPI);
		}
		return '';
	}
	
	public static function renderFormItemME($type, $tag, $groupObject, $itemObject, $pricePref, $method, $price2, $pricePref2, $displaySecondPrice) {
	
		$o = '<tr class="pm-tr-row-'.$groupObject->id.'">'
		. $tag['quantity-o'] .'<input size="8" type="text" name="itemquantity['.$itemObject->id.']" id="itemquantity'.$itemObject->id.'" value="'.$itemObject->quantity.'" />'. $tag['quantity-c']
		. $tag['title-o'] .'<input size="60" type="text" name="itemtitle['.$itemObject->id.']" id="itemtitle'.$itemObject->id.'" value="'.$itemObject->title.'" />' . $tag['title-c']
		. $tag['priceprefix-o'] . $pricePref. $tag['space'] . $tag['priceprefix-c']
		. $tag['price-o'].'<input size="8" type="text" name="itemprice['.$itemObject->id.']" id="itemprice'.$itemObject->id.'" value="'.$itemObject->price.'" />'. $tag['price-c'];
		if ($displaySecondPrice == 1) {
			$o .= $tag['price2-o'].'<input size="8" type="text" name="itemprice2['.$itemObject->id.']" id="itemprice2'.$itemObject->id.'" value="'.$itemObject->price2.'" />'. $tag['price2-c'];
		}
		$o .= '<td align="center"><input type="radio" name="itempublish['.$itemObject->id.']" id="itempublish'.$itemObject->id.'" value="1" '. (((int)$itemObject->published == 1) ? 'checked="checked"' : '' ).' /></td>'
		. '<td align="center"><input type="radio" name="itempublish['.$itemObject->id.']" id="itempublish'.$itemObject->id.'" value="0" '. (((int)$itemObject->published != 1) ? 'checked="checked"' : '' ).' /></td>'
		
		.'<td align="center"><input id="cb'.$itemObject->id.'" name="itemdelete['.$itemObject->id.']" value="0" onclick="Joomla.isChecked(this.checked);" type="checkbox" /></td>'

		.'</tr>';						
		
		// Display Description in ME in every case, if it is emtpy, display it too
		$tmpl['enablemeeditor'] = 0;
		if ($tmpl['enablemeeditor'] == 1) {
			$editor = JFactory::getEditor();
			$description = $editor->display( 'itemdesc[' . $itemObject->id .']',  $itemObject->description, '550', '300', '60', '2', array('pagebreak', 'phocadownload', 'readmore') );
		} else {
			$description = '<textarea rows="2" cols="60" name="itemdesc[' . $itemObject->id .']" id="itemdesc' . $itemObject->id .'">'. $itemObject->description . '</textarea>';
		}
		
		if ($displaySecondPrice == 1) {
			$colspan = 4;
		} else {
			$colspan = 3;
		}
		
		
		if (isset($itemObject->description)) {
			$o .= '<tr class="pmdesctr pm-tr-row-desc-'.$groupObject->id.'">'
			. $tag['quantity-o']  . $tag['space'] . $tag['quantity-c']
			. $tag['desc-o'] . $description . $tag['desc-c']
			. $tag['priceprefix-o'] . $tag['space'] . $tag['priceprefix-c']
			. $tag['price-o'] . $tag['space'] . $tag['price-c']
			. '<td colspan="'.$colspan.'"></td>'
			.'</tr>';
		}
		return $o;		
	}
	
	public static function renderTaskIconsME($displaySecondPrice) {
	
		if ($displaySecondPrice == 1) {
			$colspan = 5;
		} else {
			$colspan = 4;
		}
	
		$o = '<tr>'
		. '<td colspan="'.$colspan.'">'
		. '<td align="center" title="'.JText::_('COM_PHOCAMENU_PUBLISH').'">'.JHTML::_('image', 'media/com_phocamenu/images/icon-16-publish.png', JText::_('COM_PHOCAMENU_PUBLISH')).'</td>'
		. '<td align="center" title="'.JText::_('COM_PHOCAMENU_UNPUBLISH').'">'.JHTML::_('image', 'media/com_phocamenu/images/icon-16-unpublish.png', JText::_('COM_PHOCAMENU_UNPUBLISH')).'</td>'
		. '<td align="center" title="'.JText::_('COM_PHOCAMENU_DELETE').'">'.JHTML::_('image', 'media/com_phocamenu/images/icon-16-trash.png', JText::_('COM_PHOCAMENU_DELETE')).'</td>'
		. '</tr>';
		
		return $o;
	}
	
	public static function renderGroupHeader($displaySecondPrice, $headerPrice, $headerPrice2, $tag, $method, $type ) {
		
		$o 				= '';
		$c 				= 0;
		$headerGroup 	= '';
	
		if ($method == 4 || $method == 5) {
			// ============= BOOTSTRAP 2 | BOOTSTRAP 3=============
			if ($method == 4) {
				$span = 'span';
			} else {
				$span = 'col-sm-12 col-md-';
			}
			
			
			if ($type == 4) {
				$cP = 2;
				$sP1 = 'groupheader1-o-span2';
				$sP2 = 'groupheader2-o-span2';
			} else {
				$cP = 1;
				$sP1 = 'groupheader1-o-span1';
				$sP2 = 'groupheader2-o-span1';
			}
			if ($headerPrice != '') {
				$headerGroup .= $tag[$sP1]	. str_replace(' ', '&nbsp;', $headerPrice) . $tag['groupheader1-c']	;
				$c = $c + $cP;
			}
			if ($displaySecondPrice == 1 && $headerPrice2 != '') {
				$headerGroup .= $tag[$sP2]	. str_replace(' ', '&nbsp;', $headerPrice2) .$tag['groupheader2-c']	;
				$c = $c + $cP;
			}
			$spaceColumn = 12 - (int)$c;
			if ($headerGroup != '') {
				$o .= $tag['row-group-h-o'] . '<div class="'.$span.$spaceColumn. '"></div>'. $headerGroup . $tag['row-group-h-c'];
			}
		} else {
			// ============= TABLE =============
			if ($headerPrice != '') {
				$headerGroup .= $tag['groupheader1-o']	. str_replace(' ', '&nbsp;', $headerPrice) . $tag['groupheader1-c']	;
			}
			if ($displaySecondPrice == 1 && $headerPrice2 != '') {
				$headerGroup .= $tag['groupheader2-o']	. str_replace(' ', '&nbsp;', $headerPrice2) .$tag['groupheader2-c']	;
			}
			if ($headerGroup != '') {
				$o .= '<tr>';
				$o .=$tag['image-o'] . $tag['space']  . $tag['image-c']; // Images disabled or PDF
				$o .= $tag['quantity-o']  .  $tag['space'] . $tag['quantity-c'];
				if ($displaySecondPrice == 1 ) {
					$o .= $tag['title2-o'] . $tag['space']  . $tag['title2-c'];
				} else {
					$o .= $tag['title-o'] . $tag['space']  . $tag['title-c'];
				}
				$o .= $tag['priceprefix-o'] . $tag['space']  . $tag['priceprefix-c']. $headerGroup;
				$o .= '</tr>';
			}
		}
		
		return $o;
	}
	
	public static function renderGroupHeaderME($groupObject, $tag ) {
	
		$o = '';
		$headerGroup = '';
		if ($groupObject->header_price != '') {
			$headerGroup .= $tag['groupheader1-o']	. '<input size="8" type="text" name="groupheaderprice['.$groupObject->id.']" id="groupheaderprice'.$groupObject->id.'" value="'.$groupObject->header_price.'" />' . $tag['groupheader1-c']	;
		} else {
			$headerGroup .= '<td></td>';
		}
		if ($groupObject->display_second_price == 1 && $groupObject->header_price2 != '') {
			$headerGroup .= $tag['groupheader2-o']	. '<input size="8" type="text" name="groupheaderprice2['.$groupObject->id.']" id="groupheaderprice'.$groupObject->id.'" value="'.$groupObject->header_price2.'" />' .$tag['groupheader1-c']	;
		} else {
			$headerGroup .= '<td></td>';
		}
		
		if ($headerGroup != '') {
			$o .= '<tr>'
			//. $tag['image-o'] . $tag['space'] . $tag['image-c'] // Images disabled or PDF
			. $tag['quantity-o']  .  $tag['space'] . $tag['quantity-c'];
			if ($groupObject->display_second_price == 1 ) {
				$o .= $tag['title2-o'] . $tag['space'] . $tag['title2-c'];
			} else {
				$o .= $tag['title-o'] . $tag['space'] . $tag['title-c'];
			}
			$o .= $tag['priceprefix-o'] . $tag['space'] . $tag['priceprefix-c']. $headerGroup;
		}
		
		if ($groupObject->display_second_price == 1) {
			$colspan = 4;
		} else {
			$colspan = 2;
		}
		
		$o .= '<td colspan="'.$colspan.'"></td>';
		$o .= '</tr>';
		return $o;
	}
	
	public static function renderFormCompleteRE($oP) {
		
		$oPO = '<textarea name="menudata" id="menudata" rows="30" style="width: 90%;">';
		if (!empty($oP)) {
			$oPO .= implode("\n", $oP);
		}
		$oPO .= '</textarea>';
		
		return $oPO;
	}
	
	public static function getCustomCode($code, $header, $method) {
		$o = '';
		if ($code != '') {
			if ($method == 4) { 
				$o .=  '<div class="row fluid-row pm-customcode">'
				 .'<div class="span3 pmclock">'.$code.'</div>'
				 .'<div class="span9 pmtext">' . $header . '</div>'
				 .'</div>';
			} if ($method == 5) {
				$o .=  '<div class="row fluid-row pm-customcode">'
				 .'<div class="col-xs-12 col-sm-3 col-md-3 pmclock">'.$code.'</div>'
				 .'<div class="col-xs-12 col-sm-9 col-md-9 pmtext">' . $header . '</div>'
				 .'</div>';
			}else {
				$o .=  '<table><tr>'
				 .'<td class="pmclock" colspan="2">'.$tmpl['customclockcode'].'</td>'
				 .'<td class="pmtext">' . $data['config']->header . '</td>'
				 .'</tr></table>';
			}
		} else {
			$o .=  $header;
		}
		return $o;
	}
	
	public static function setMethod($params, $method) {
		
		$app = JFactory::getApplication();
		$print = $app->input->get('print', 0, 'int');
		
		if ($print == 1) {
			return $method;
		}
		if ($method == 2) {
			return $method;//PDF
		}
		if ($method == 3) {
			return $method;//Form Multiple EDIT
		}
		if ($method == 6) {
			return $method;//Form Raw Edit
		}
		if ($params->get( 'html_output', 1 ) == 2 ) {
			return 4;
		}
		if ($params->get( 'html_output', 1 ) == 3 ) {
			return 5;
		}
		
		return $method;
	}
	
	public static function setMainId($method) {
		
		$o = '';
		switch($method) {
			case 3:		$o = '<div id="phocamenumultipleedit">';break;
			case 4:		$o = '<div id="phocamenu" class="bts2">';break;
			case 5:		$o = '<div id="phocamenu" class="bts3">';break;
			case 6:		$o = '<div id="phocamenurawedit">';break;
			default:	$o = '<div id="phocamenu">'; break;
		}
		return $o;
		
	}
}
?>